import java.io.*;
import java.util.*;

public class jeroen {
    public static void main(String[] args) {
	Scanner sc = new Scanner(System.in);
	int tests = sc.nextInt();
	while(tests-- > 0) {
	    long m = sc.nextLong();
	    ArrayList<Pair<Long, Long>> lst = new ArrayList<Pair<Long, Long>>();

	    // Loop over all k, where k <= n/2, so minimum result is choose(k*2, k),
	    // continue as long as k is small enough to lead to results (will increase quickly)
	    for(long k = 1; choose(k * 2, k, m) <= m; k++) {
		// for a specific k, binary seach for n
		long low = k * 2;
		long up = m;
		while(low != up) {
		    long act = (low + up) / 2;
		    if(choose(act, k, m) < m)
			low = act + 1;
		    else
			up = act;
		}
		long n = low; // == up

		// Check if the resulting value is exactly m, if yes then add to result
		// list as well as the mirrored value (choose(n,k) == choose(n,n-k))
		if(choose(n, k, m) == m) {
		    lst.add(new Pair<Long, Long>(n, k));
		    if(low - k != k)
			lst.add(new Pair<Long, Long>(n, n - k));
		}
	    }

	    // Sort and print the resultingvalues
	    int numret = lst.size();
	    System.out.println(numret);
	    Collections.sort(lst);
	    for(int i = 0; i < numret; i++) {
		if(i > 0) System.out.print(' ');
		System.out.print("("+lst.get(i).first+","+lst.get(i).second+")");
	    }
	    System.out.println();
	}
    }

    // Binomial coefficient, choose k items from n, stop when return value
    // is larger than max
    public static long choose(long n, long k, long max)
    {
	if (k > n)
	    return 0;
	if (k > n / 2)
	    k = n - k;
	double accum = 1;
	for (long i = 1; i <= k; i++) {
	    accum = accum * (n - k + i) / i;
	    if (accum > max) return max + 1;
	}
	return (long)(accum + 0.5);
    }

    public static class Pair<A extends Comparable<A>,B extends Comparable<B>> implements Comparable<Pair<A,B>> {
	public A first;
	public B second;

	public Pair(A f, B s) {
	    first = f;
	    second = s;
	}

	public int compareTo(Pair<A,B> other) {
	    int c1 = first.compareTo(other.first);
	    if(c1!=0) return c1;
	    return second.compareTo(other.second);
	}
    }
}