// Author: Adrian Kuegel
// Date: August 1st, 2011
// Algorithm: brute force, binary search
// Complexity: O((log m)^3)

#include <stdio.h>
#include <math.h>
#include <utility>
#include <vector>
#include <algorithm>
using namespace std;

typedef pair<long long, long long> PLL;
typedef vector<PLL> VPLL;

long long calc_bino(long long n, int k) {
	double res = n-k+1;
	for (int i=2; i<=k; ++i) 
		res = res * (n-k+i) / i;
	if (res > pow(10, 16))
		return ((long long)pow(10, 16));
	return (long long)res;
}

int main() {
	long long m;
	int tc;
	scanf("%d", &tc);
	while(tc--) {
		scanf("%lld", &m);
		long long up = m;
		VPLL sol;
		// this loop runs in O(log m) (until (2 k over k) exceeds m)
		for (int k=1; k; ++k) {
			long long lo = 2 * k;
			// again O(log m)
			while(lo <= up) {
				long long mid = (lo+up) / 2;
				// again O(log m)
				long long res = calc_bino(mid, k);
				if (res == m) {
					if (mid == 2 * k)
						sol.push_back(PLL(mid, k));
					else {
						sol.push_back(PLL(mid, k));
						sol.push_back(PLL(mid, mid-k));
					}
					up = mid;
					break;
				}
				if (res > m)
					up = mid - 1;
				else
					lo = mid + 1;
			}
			if (up < 2 * k)
				break;
		}
		printf("%d\n", sol.size());
		sort(sol.begin(), sol.end());
		for (int i=0; i<(int)sol.size(); ++i)
			printf("(%lld,%lld)%c", sol[i].first, sol[i].second, i+1==(int)sol.size()?'\n':' ');
	}
	return 0;
}
