//Author: Lukas Polacek
//Precalculation + binary search
#include <iostream>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>
#include <cstdio>
#include <cmath>
using namespace std;

#define rep(i,a,b) for(__typeof(b) i=a; i<(b); ++i)

typedef long long ll;
typedef pair<ll, ll> pll;
ll c(ll n, int m)
{
    ll res = 1;
    rep(j,1,m+1)
    {
        if (log(res) + log(n - j + 1) - log(j) > 16 * log(10))
            return (ll)1e16;
        res = res * (n - j + 1) / j;
    }
    return res;
}
int main()
{
    map<ll, vector<pll> > num;
    int q = 50000;
    rep(i,0,q)
    {
        ll c = 1;
        rep(j,1,i+1)
        {
            if (2 * j > i)
                break;
            if (log(c) + log(i - j + 1) - log(j) > 16 * log(10))
                break;
            c = c * (i - j + 1) / j;
            num[c].push_back(pll(i, j));
            if (2 * j < i)
                num[c].push_back(pll(i, i - j));
        }
    }

    int cases; scanf("%d", &cases);
    rep(cas,0,cases)
    {
        ll n; scanf("%lld", &n);
        vector<pll> res = num[n];
        for (int k = 4; k >= 1; k--)
        {
            ll a = 0, b = n;
            while (a + 1 < b)
            {
                ll m = (a + b) / 2;
                if (c(m, k) >= n)
                    b = m;
                else
                    a = m;
            }
            if (b >= q && c(b, k) == n)
            {
                res.push_back(pll(b, k));
                res.push_back(pll(b, b - k));
            }
        }

        printf("%d\n", res.size());
        rep(i,0,res.size())
        {
            printf("(%lld,%lld)", res[i].first, res[i].second);
            printf(i + 1 < res.size() ? " " : "\n");
        }
    }
}
