#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <assert.h>

struct frac {
	int n, d;
};

struct frac inverse(struct frac f) { // 1 / frac
	struct frac ret;
	ret.n = f.d;
	ret.d = f.n;
	return ret;
}

struct frac minusone(struct frac f) { // f - 1
	struct frac ret;
	ret.n = f.n - f.d;
	ret.d = f.d;
	return ret;
}

int gcd(int a, int b) {
	return b == 0 ? a : gcd(b, a % b);
}

void testcase() {
	struct frac f;
	int len = 0;
	scanf("%d/%d\n",&f.n,&f.d);
	assert(f.n != f.d);
	assert(gcd(f.n,f.d) == 1);
	assert(f.n <= 1000000000);
	assert(f.d <= 1000000000);
	while(f.n != f.d) { // f != 1
		len++;
		if(f.n < f.d) { // f < 1
			putchar('L');
			f = minusone(inverse(f));
		} else { // f > 1
			putchar('R');
			f = inverse(minusone(f));
		}
	}
	putchar('\n');
	assert(len <= 10000);
}

int main() {
	int t;
	scanf("%d\n",&t);
	while(t--) testcase();
	return 0;
}
