// Birdtree
// Solution by Thomas Beuman

// This algorithm goes from the top of the tree down,
// but works by calculating the nodes rather than changing the target

#include <cstdio>
using namespace std;

char Dir[10001];

// Compare fractions (-1 for a1/b1 < a2/b2, +1 for >, 0 for =)
int cmp (int a1, int b1, int a2, int b2)
{ long long x = (long long)a1*b2, y = (long long)a2*b1;
  return x < y ? -1 : x == y ? 0 : 1;
}

int main()
{ int runs, run, a, b, m11, m12, m21, m22, n11, n12, n21, n22, i, res;
  scanf("%d\n", &runs);
  for (run = 0; run < runs; run++)
  { scanf("%d/%d\n", &a, &b);
    // Initialize m to identity matrix
    m11 = m22 = 1;
    m12 = m21 = 0;
    for (i = 0; true; i++)
    { // Number at node = (m11+m12) / (m21+m22)
      res = cmp(a, b, m11+m12, m21+m22); // See if the target is larger or smaller than the node
      if (res == 0)
        break;
      if ((res == 1) ^ (i&1)) // Alternatingly go left/right if the target is smaller
      { Dir[i] = 'R';
        // Multiply m to the right with [1 1] ( x/y -> (x+y)/x )
        //                              [1 0]
        n11 = m11 + m12;
        n12 = m11;
        n21 = m21 + m22;
        n22 = m21;
      }
      else
      { Dir[i] = 'L';
        // Multiply m to the right with [0 1] ( x/y -> y/(x+y) )
        //                              [1 1]
        n11 = m12;
        n12 = m11 + m12;
        n21 = m22;
        n22 = m21 + m22;
      }
      m11 = n11;  m12 = n12;  m21 = n21;  m22 = n22;
    }
    Dir[i] = '\0';
    printf("%s\n", Dir);
  }
  return 0;
}
