// Piece it Together
// Solution by Thomas Beuman

import java.io.*;
import java.util.*;

public class thomas_2sat
{
  public static int NN = 1000000;
  public static int[] di = {0, -1, 0, 1};
  public static int[] dj = {-1, 0, 1, 0};

  public static int n, m;
  public static String[] Pattern;
  
  public static void main (String[] args)
  { Scanner sc = new Scanner(System.in);
    int tests = sc.nextInt();
    while (tests-- > 0)
    { n = sc.nextInt();
      m = sc.nextInt();
      Pattern = new String[n+2];
      String line;
      for (int i = 1; i <= n; i++)
      { line = sc.next();
        Pattern[i] = '.' + line + '.';
      }
      char[] charArray = new char[m+2];
      Arrays.fill(charArray, '.');
      Pattern[0] = new String(charArray);
      Pattern[n+1] = new String(charArray);
      System.out.println(possible() ? "YES" : "NO");
    }
  }

  public static boolean possible()
  { int i, j, b, w, C, x, y, k1, k2, id[] = new int[4];
    boolean b1, b2, W[] = new boolean[4];
    b = w = 0;
    C = 0;
    for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
      { id[0] = (i-1)*m+j - 1;
        id[1] = (i-1)*m+j - m + n*m;
        id[2] = (i-1)*m+j;
        id[3] = (i-1)*m+j + n*m;
        if (Pattern[i].charAt(j) == 'B')
        { b++;
          for (x = 0; x < 2; x++) // For both directions
          { b1 = Pattern[i+di[x]].charAt(j+dj[x]) == 'W';
            b2 = Pattern[i+di[x+2]].charAt(j+dj[x+2]) == 'W';
            k1 = id[x];
            k2 = id[x+2];
            if (b1 || b2)
            { Cl[C++] = new clause(b1 ? k1 : k2, b2 ? k2 : k1);
              //if (b1 && b2) // Ensuring exclusive or is not necessary
                //Cl[C++] = new clause(-k1, -k2);
            }
            else
              return false;
          }
        }
        else if (Pattern[i].charAt(j) == 'W')
        { w++;
          for (x = 0; x < 4; x++)
            W[x] = Pattern[i+di[x]].charAt(j+dj[x]) == 'B';
          for (x = 0; x < 3; x++)
            for (y = x+1; y < 4; y++)
              if (W[x] && W[y])
                Cl[C++] = new clause(-id[x], -id[y]);
        }
      }
    return w == 2*b && twosat(2*n*m, C);
  }

  /*** Strongly connected components ***/

  public static int teller, vlowlink[] = new int[NN], vlink[] = new int[NN];
  public static Stack S;
  public static int situatie[]; // 0 = not seen yet, 1 = in stack, 2 = processed
  @SuppressWarnings("unchecked")
  public static LinkedList<Integer>[] adj = new LinkedList[NN];
  public static int sccnr[] = new int[NN], cur;

  @SuppressWarnings("unchecked")
  public static void sccrec (int v)
  { vlink[v] = vlowlink[v] = teller++;
	  S.push(new Integer(v));
    situatie[v] = 1;
    for (int buur : adj[v])
      if (situatie[buur] < 2)
      { if (situatie[buur] == 0)
          sccrec(buur);
        if (vlowlink[v] > vlowlink[buur])
          vlowlink[v] = vlowlink[buur];
      }
    if (vlowlink[v] == vlink[v])
    { int w;
      do
      { sccnr[w = (Integer)S.pop()] = cur;
        situatie[w] = 2;
      }
      while (w != v);
      cur++;
    }
  }

  public static void strongly_connected_components (int n)
  { situatie = new int[n];
    S = new Stack();
    teller = cur = 0;
    for (int i = 0; i < n; i++)
      if (situatie[i] < 2)
        sccrec(i);
  }

  /*** 2SAT ***/

  // Returns whether there is a solution to an equation of the form:
  // true = (A1 || A2) && (B1 || B2) && ...
  // where Xi and Yj can be equal statements or each others negation
  // K = number of statements (1 t/m K), C = number of clauses

  public static clause[] Cl = new clause[NN]; // The clauses: Cl[i].first || Cl[i].second (-a = !a)

  public static boolean twosat (int K, int C)
  { int i;
    for (i = 0; i <= 2*K; i++)
      adj[i] = new LinkedList<Integer>();
    for (i = 0; i < C; i++)
    { adj[K - Cl[i].first].add(K + Cl[i].second);
      adj[K - Cl[i].second].add(K + Cl[i].first);
    }
    strongly_connected_components(2 * K + 1);
    for (i = 1; i <= K; i++)
      if (sccnr[K + i] == sccnr[K - i])
        return false;
    return true;
  }
    
  public static class clause
  { public int first, second;
    public clause (int a, int b)
    { this.first = a;
      this.second = b;
    }
  }
}
