import java.io.*;
import java.util.*;

public class jeroen {
    public static void main(String[] args) {
	Scanner sc = new Scanner(System.in);
	int tests = sc.nextInt();
	while(tests-- > 0) {
	    cards = new Card[13];
	    for(int i = 0; i < 13; i++)
		cards[i] = new Card(sc.next());
	    done = new boolean[1 << 13];
	    mem = new int[1 << 13];
	    // First get the answer and fill the table
	    System.out.println(rec((1 << 13) - 1, false));
	    // Then recurse again to print combinations
	    rec((1 << 13) - 1, true);
	}
    }

    public static boolean[] done;
    public static int[] mem;
    public static Card[] cards;

    // avail is bitmask of cards that are left
    public static int rec(int avail, boolean print) {
	if(avail== 0) return 0;
	if(!print) {
	    if(done[avail]) return mem[avail];
	    done[avail] = true;
	    mem[avail] = Integer.MAX_VALUE;
	}

	// Find out what cards we have left
	int[] nval = new int[13];
	int[][] ival = new int[13][4];
	for(int i = 0; i < 13; i++)
	    if(((1 << i) & avail) > 0)
		ival[cards[i].value][nval[cards[i].value]++] = i;

	// Keep lists for full house
	LinkedList<Integer> allrem2 = new LinkedList<Integer>();
	LinkedList<Integer> allrem3 = new LinkedList<Integer>();

	// Loop over all available values
	for(int v = 0; v < 13; v++) {
	    if(nval[v] >= 1) {
		// Single card
		int rem = 1 << ival[v][0];
		if(recHelp(avail, rem, print)) return -1;

		if(nval[v] >= 2) {
		    // Pair of cards
		    rem |= 1 << ival[v][1];
		    if(recHelp(avail, rem, print)) return -1;
		    allrem2.add(rem);

		    if(nval[v] >= 3) {
			// Tree cards of same value
			rem |= 1 << ival[v][2];
			if(recHelp(avail, rem, print)) return -1;
			allrem3.add(rem);

			if(nval[v] >= 4) {
			    // Four cards of same value
			    rem |= 1 << ival[v][3];
			    if(recHelp(avail, rem, print)) return -1;
			}
		    }
		}

		// Possible start of straight here
		int straight = 1 << ival[v][0];
		int straightlen = 1;
		for(int v2 = v + 1; v2 < 13 && nval[v2] >= 1; v2++) {
		    straight |= 1 << ival[v2][0];
		    straightlen++;

		    // Check for valid straights
		    if(straightlen >= 5 && recHelp(avail, straight, print))
			return -1;
		}
	    }
	}

	// Loop over possible full houses
	for(int m2 : allrem2)
	    for(int m3 : allrem3)
		if((m2 & m3) == 0) // sets of cards must be distinct
		    if(recHelp(avail, m2 | m3, print))
			return -1;

	return mem[avail];
    }

    // Helper does recursive call and updates mem table when print == false,
    // otherwise it will check if this is a desired answer and then print it
    private static boolean recHelp(int av, int usemask, boolean print) {
	int newval = rec(av & ~usemask, false) + 1;
	if(print) {
	    // If newval == mem[av], this is part of the solution so print and recursively
	    // continue printing
	    if(newval == mem[av]) {
		boolean first = true;
		for(int i = 0; i < 13; i++) {
		    if((usemask & (1<<i)) > 0) {
			if(!first) System.out.print(' ');
			System.out.print(cards[i]);
			first = false;
		    }
		}
		System.out.println();
		rec(av & ~usemask, true);
		return true;
	    }
	} else {
	    mem[av] = Math.min(mem[av], newval);
	}
	return false;
    }

    private static class Card {
	public int value, suit;
	private static String values = "23456789TJQKA";
	private static String suits = "hdcs";


	public Card(String c) {
	    value = values.indexOf(c.charAt(0));
	    suit = suits.indexOf(c.charAt(1));
	}

	public String toString() {
	    return values.charAt(value) + "" + suits.charAt(suit);
	}
    }
}