// @EXPECTED_RESULTS@: CORRECT

#include <stdio.h>
#include <vector>
#include <map>
#include <string>
#include <algorithm>

using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); i++)
#define NOT 20

typedef struct {
	int suit, val;
} card;

const char *suit = "hdcs";
const char *order = "23456789TJQKA";
map<char,int> value;
map<char,int> suits;
card cards[13];

int dp[1<<13];
int chosen[1<<13];

int main(int argc, char **argv) {
	FOR(i, 0, 13) value[order[i]] = i;
	FOR(i, 0, 4) suits[suit[i]] = i;

	int numCases;
	scanf("%d", &numCases);
	while (numCases --> 0) {
		FOR(i, 0, 13) {
			char buf[5];
			scanf("%s", buf);
			cards[i].suit = suits[buf[1]];
			cards[i].val = value[buf[0]];
		}

		FOR(i, 1, (1<<13)) {
			dp[i] = NOT;
			chosen[i] = i;
			
			int ranks[13];
			int numCards = 0;
			int mini = 13; int maxi = -1;
			FOR(j, 0, 13) ranks[j] = 0;
			FOR(j, 0, 13) {
				if ((1<<j) & i) {
					ranks[cards[j].val]++;
					mini = min(mini, cards[j].val);
					maxi = max(maxi, cards[j].val);
					numCards++;
				}
			}
			bool pair = false, triple = false, quadruple = false;
			FOR(j, 0, 13) {
				pair |= (ranks[j] == 2);
				triple |= (ranks[j] == 3);
				quadruple |= (ranks[j] == 4);
			}

			if (numCards == 1
				|| (numCards == 2 && pair)
				|| (numCards == 3 && triple)
				|| (numCards == 4 && quadruple)
				|| (numCards == 5 && pair && triple)
				|| (!pair && !triple && !quadruple && numCards >= 5 && maxi + 1 - mini == numCards)
				) {
				dp[i] = 1;
			}
		}

		bool changed = true;
		while (changed) {
			changed = false;
			FOR(i, 1, (1<<13)) {
				if (dp[i] > 1) continue;
				FOR(j, i + 1, (1<<13)) {
					if (dp[i] != NOT && dp[j] != NOT && ((i & j) == 0) && dp[i] + dp[j] < dp[i+j]) {
						dp[i+j] = dp[i] + dp[j];
						chosen[i+j] = i;
						changed = true;
					}
				}
			}
		}

		int cur = (1<<13)-1;
		printf("%d\n", dp[cur]);
		while (cur != 0) {
			bool first = true;
			FOR(i, 0, 13) {
				if (chosen[cur] & (1<<i)) {
					if (first) {
						first = false;
					} else {
						putchar(' ');
					}
					printf("%c%c", order[cards[i].val], suit[cards[i].suit]);
				}
			}
			puts("");
			cur -= chosen[cur];
		}
	}

	return 0;
}
